#Include "Include/inc_datatypes.bi"
#Include "Include/inc_register.bi"
'#Include "Include/inc_stack.bi"
#Include "Include/inc_flags.bi"
#Include "Include/inc_interrupts.bi"
#Include "Include/inc_commands.bi"

Type Func
	As String nam
	As String code(999)
	As Integer anzlines
End Type

Type Label
	As String nam
	As String code(999)
	As Integer anzlines
End Type

Dim Shared As Func functions(999)
Dim Shared As Label labels(999)

Declare Function StrReplace(s As String, erlaubt As String)As String
Declare Sub ExecFunc(fu As Integer)
Declare Function ReadNextLine ( ByVal FF As Integer ) As String
Declare Function ReadPrevLine ( ByVal FF As Integer, ByVal bracke As UByte = 10, ByVal Length As Integer = 2 ) As String 

Dim Shared As String lina,lina2,lin,lindata,lindataa,lindataa2,cmdn,cmdp1,cmdp2,dat(999),datvar(999),null
Dim Shared As String flina,flina2,flin,fflina,fflina2,fflin,fnull
Dim Shared As Integer spac,comma,null2,idat(999),lines,anzfuncs,ffout,anzlabels,linestart
If Command(1)="--help" Then
	Print "Aufruf: interpreter [DATEI] [OPTION]."
	Print " Beispiel: interpreter test.asm -d"
	
	Print "Die Datei [DATEI] mit der Option [OPTION] als Assembler2000 Sourcecode ausführen"
	Print ""
	Print "  -v   Anzeigen der Assembler-2000 Versionsnummer"
	Print "  -l   WTFPL-Lizienzhinweis"
	Print "  -d   Zeige jede Codezeile und den Status der Register AX,BX,CX und DX an"
	Print "  -f   Anzeigen der Funktionsaufrufe und des Codes der Funktionen"
	Print "  -p   Anzeigen jeder Codezeile"
	End
Elseif Command(1)="-v" Then
	Print "Assembler-2000 Interpreter Beta 0.2"
	End
Elseif Command(1)="-l" Then
	Print "DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE"
	Print "         Version 2, December 2004"
	Print ""
	Print "Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>"
	Print ""
	Print "Everyone is permitted to copy and distribute verbatim or modified"
	Print "copies of this license document, and changing it is allowed as long"
	Print "as the name is changed."
	Print ""
	Print "        DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE"
	Print " TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION"
	Print ""
	Print " 0. You just DO WHAT THE FUCK YOU WANT TO. "
	End
End If
Var fff=Freefile
Open Command(1) For Input As #fff
ffout=Freefile
Open Cons For Output As #ffout

If Command(2)="-d" Or Command(2)="-f" Then Print "Erster Durchlauf: Nach Funktionen und Labels suchen"

Do Until Eof(fff)
Line Input #fff,flina
	flina2=StrReplace(flina,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,:;-_!§$%&/()[]=?ß*'+# ")
	
	'#####################-COMMENTARS-#####################
	
	If Instr(flina2,";") Then
		Dim As Integer possem=Instr(flina2,";")
		flin=Left(flina2,possem-1)
	Else
		flin=flina2
	End If
	
	If Instr(Ucase(flin),"FUNC") Then
		anzfuncs+=1
		functions(anzfuncs).nam=Mid(flin,6)
		If Command(2)="-d" Or Command(2)="-f" Then Print "Funktion gefunden: "+functions(anzfuncs).nam
		If Command(2)="-d" Or Command(2)="-f" Then Print "------------------"+functions(anzfuncs).nam+"------------------"
		For i As Integer=1 To 999
			Line Input #fff,fflina
			fflina2=StrReplace(fflina,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,:;-_!§$%&/()[]=?ß*'+# ")
			
			'#####################-COMMENTARS-#####################
			
			If Instr(fflina2,";") Then
				Dim As Integer possem=Instr(fflina2,";")
				fflin=Left(fflina2,possem-1)
			Else
				fflin=fflina2
			End If
			functions(anzfuncs).code(i)=fflin
			functions(anzfuncs).anzlines+=1
			If Command(2)="-d" Or Command(2)="-f"  Then Print functions(anzfuncs).code(i)
			If Instr(Ucase(fflin),"RET") Then Exit For
		Next
		If Command(2)="-d" Or Command(2)="-f" Then Print "----------------------------------------"
	End If
Loop

Var ff=Freefile
Open Command(1) For Input As #ff
Do Until Eof(ff)
	Line Input #ff,lina
	lina2=StrReplace(lina,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,:;-_!§$%&/()[]=?ß*'+# ")
	
	'#####################-COMMENTARS-#####################
	
	If Instr(lina2,";") Then
		Dim As Integer possem=Instr(lina2,";")
		lin=Left(lina2,possem-1)
	Else
		lin=lina2
	End If
	
	If Command(2)="-d" Or Command(2)="-p" Then Print #ffout,lin	
	
	 If lin=".data" Then
		Input #ff,null2
		For i As Integer=1 To null2
			Line Input #ff,lindataa
			lindataa2=StrReplace(lindataa,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,:;-_!§$%&/()[]=?ß*'+# ")
			If Instr(lindataa2,";") Then
				Dim As Integer possem=Instr(lindataa2,";")
				lindata=Left(lindataa2,possem-1)
			Else
				lindata=lindataa2
			End If
			If Command(2)="-d" Or Command(2)="-p" Then Print #ffout,lindata
			datvar(i)=Left(lindata,5)
			dat(i)=Mid(lindata,6)
		Next
	End If
	If lin=".code" Then Continue Do
	
	If lin = "" Then Continue Do 
	spac = Instr(lin, " ") 
	If spac < 1 Then Continue Do
	cmdn = Left(lin,spac-1) 
	comma = Instr(spac, lin, ",") 
	'If comma < 1 Then Continue Do
	cmdp1=  Trim(Mid(lin, spac + 1, comma - spac - 1))
    cmdp2 = Trim(Mid(lin, comma + 1)) 
    	
	'#####################-MOV-#####################
	
	If Ucase(cmdn)=MOV.title Then
		MOV.p1=cmdp1
		MOV.p2=cmdp2
		For i3 As Integer=1 To null2
			If MOV.p1="["+datvar(i3)+"]" Then
				Idat(i3)=Val(Dat(i3))
				For i4 As Integer=1 To 12
					If MOV.p2=Reg(i4).title Then
						Idat(i3)=Val(Reg(i4).content.scontent)
					Elseif MOV.p2="["+datvar(i4)+"]" Then
						Idat(i3)=Val(dat(i4))
					Else
						Idat(i3)=Val(MOV.p2)
					End If
				Next
				Dat(i3)=Str(Idat(i3))
			End If
		Next
		For i3 As Integer=1 To 12
			If Ucase(MOV.p1)=Reg(i3).title Then
				Reg(i3).content.content=Val(Reg(i3).content.scontent)
				For i4 As Integer=1 To 12
					If Ucase(MOV.p2)=Reg(i4).title Then
						Reg(i3).content.scontent=Reg(i4).content.scontent
					End If
				Next
				For i4 As Integer=1 To null2
				If Instr(MOV.p2,"["+datvar(i4)+"]") Then
					Reg(i3).content.scontent=dat(i4)
				End If
				Next
				If Instr(Ucase(MOV.p2),"%") Then
					For i5 As Integer=1 To null2
						If Mid(MOV.p2,2)=datvar(i5) Then
							Reg(i3).content.scontent=dat(i5)
							LastReg=Reg(i3)
						End If
					Next
				End If
				If (Instr(cmdp2,"h") And (Instr(cmdp2,"0")Or Instr(cmdp2,"1") Or Instr(cmdp2,"F"))) Or (Instr(cmdp2,"b") And Instr(cmdp2,"1")) Then
					Reg(i3).content.scontent=MOV.p2
				End If
				If MOV.p2=Str(Val(MOV.p2)) Then
					Reg(i3).content.content=Val(MOV.p2)
					Reg(i3).content.scontent=Str(Reg(i3).content.content)
				End If
			End If
		Next
			
	 '#####################-DEC-#####################
	
	Elseif Ucase(cmdn)=DEC.title Then
		DEC.p1=cmdp1
		For i As Integer=1 To 12+null2
			If Ucase(DEC.p1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content-=1
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(i)
			Elseif DEC.p1="["+Datvar(i)+"]" Then
				Idat(i)=Val(Dat(i))
				Idat(i)-=1
				Dat(i)=Str(Idat(i))
			End If
		Next
		
	'#####################-INC-#####################
	
	Elseif Ucase(cmdn)=INC.title Then
		INC.p1=cmdp1
		For i As Integer=1 To 12+null2
			If Ucase(INC.p1)=Reg(i).title Then 
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content+=1
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(i)
				Elseif INC.p1="["+Datvar(i)+"]" Then
					Idat(i)=Val(Dat(i))
					Idat(i)+=1
					Dat(i)=Str(Idat(i))
			End If
		Next
		
	'#####################-ADD-#####################
	
	Elseif Ucase(cmdn)=ADD.title Then
		ADD.p1=cmdp1
		ADD.p2=cmdp2
		For i3 As Integer=1 To null2
			If ADD.p1="["+datvar(i3)+"]" Then
				Idat(i3)=Val(Dat(i3))
				For i4 As Integer=1 To 12
					If Ucase(ADD.p2)=Reg(i4).title Then
						Idat(i3)+=Val(Reg(i4).content.scontent)
						Exit For
					Elseif ADD.p2="["+datvar(i4)+"]" Then
						Idat(i3)+=Val(dat(i4))
						Exit For
					Else
						Idat(i3)+=Val(ADD.p2)
						Exit For
					End If
				Next
				Dat(i3)=Str(Idat(i3))
			End If
		Next
		For i3 As Integer=1 To 12
			If Ucase(ADD.p1)=Reg(i3).title Then
				Reg(i3).content.content=Val(Reg(i3).content.scontent)
				For i4 As Integer=1 To 12
					If Ucase(ADD.p2)=Reg(i4).title Then
						Reg(i3).content.content+=Val(Reg(i4).content.scontent)
						Exit For
					Elseif ADD.p2="["+datvar(i4)+"]" Then
						Reg(i3).content.content+=Val(dat(i4))
						Exit For
					Else
						Reg(i3).content.content+=Val(ADD.p2)
						Exit For
					End If
				Next
				Reg(i3).content.scontent=Str(Reg(i3).content.content)
			End If
		Next
			
	'#####################-SUB-#####################
	
	 Elseif Ucase(cmdn)=SUB2.title Then
		SUB2.p1=cmdp1
		SUB2.p2=cmdp2
		For i3 As Integer=1 To null2
			If SUB2.p1="["+datvar(i3)+"]" Then
				Idat(i3)=Val(Dat(i3))
				For i4 As Integer=1 To 12
					If Ucase(SUB2.p2)=Reg(i4).title Then
						Idat(i3)-=Val(Reg(i4).content.scontent)
						Exit For
					Elseif SUB2.p2="["+datvar(i4)+"]" Then
						Idat(i3)-=Val(dat(i4))
						Exit For
					Else
						Idat(i3)-=Val(SUB2.p2)
						Exit For
					End If
				Next
				Dat(i3)=Str(Idat(i3))
			End If
		Next
		For i3 As Integer=1 To 12
			If Ucase(SUB2.p1)=Reg(i3).title Then
				Reg(i3).content.content=Val(Reg(i3).content.scontent)
				For i4 As Integer=1 To 12
					If Ucase(SUB2.p2)=Reg(i4).title Then
						Reg(i3).content.content-=Val(Reg(i4).content.scontent)
						Exit For
					Elseif SUB2.p2="["+datvar(i4)+"]" Then
						Reg(i3).content.content-=Val(dat(i4))
						Exit For
					Else
						Reg(i3).content.content-=Val(SUB2.p2)
						Exit For
					End If
				Next
				Reg(i3).content.scontent=Str(Reg(i3).content.content)
			End If
		Next
		
		'#####################-INT-#####################
		
	Elseif Ucase(cmdn)=INT2.title Then
		INT2.p1=cmdp1
		If INT2.p1="42h" Then
			If Command(2)<>"--debug" Then SysInterrupt()
		End If
		If INT2.p1="10h" Then 
			If Command(2)<>"--debug" Then BIOSInterrupt()
		End If
		
		'#####################-NEG-#####################
		
	Elseif Ucase(cmdn)=NEG.title Then
		NEG.p1=cmdp1
		For i As Integer=1 To 12
			If Ucase(NEG.p1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content=0-Reg(i).content.content
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(i)
			End If
		Next
		For i2 As Integer=1 To null2
			If NEG.p1="["+datvar(i2)+"]" Then
				Idat(i2)=Val(dat(i2))
				Idat(i2)=0-Idat(i2)
				dat(i2)=Str(Idat(i2))
			End If
		Next
		
		'#####################-MUL-#####################
		
	Elseif Ucase(cmdn)=MUL.title Then
		MUL.p1=cmdp1
		If Ucase(MUL.p1)=Str(Val(MUL.p1)) Then
			Reg(1).content.content=Val(Reg(1).content.scontent)
			Reg(1).content.content=Val(MUL.p1)*Reg(1).content.content
			Reg(1).content.scontent=Str(Reg(1).content.content)
			LastReg=Reg(1)
		End If
		For i As Integer=1 To 12
			If Ucase(MUL.p1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Reg(i).content.content*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(1)
			End If
		Next
		For i2 As Integer=1 To null2
			If MUL.p1="["+datvar(i2)+"]" Then
				Idat(i2)=Val(dat(i2))
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Idat(i2)*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				dat(i2)=Str(Idat(i2))
				LastReg=Reg(1)
			End If
		Next
		
		'#####################-DIV-#####################
		
	Elseif Ucase(cmdn)=DIV.title Then
		DIV.p1=cmdp1
		If Ucase(DIV.p1)=Str(Val(DIV.p1)) Then
			Reg(1).content.content=Val(Reg(1).content.scontent)
			Reg(1).content.content=Reg(1).content.content/Val(DIV.p1)
			Reg(1).content.scontent=Str(Reg(1).content.content)
			LastReg=Reg(1)
		End If
		For i As Integer=1 To 12
			If Ucase(DIV.p1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Reg(1).content.content/Reg(i).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(1)
			End If
		Next
		For i2 As Integer=1 To null2
			If DIV.p1="["+datvar(i2)+"]" Then
				Idat(i2)=Val(dat(i2))
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Reg(1).content.content/Idat(i2)
				Reg(1).content.scontent=Str(Reg(1).content.content)
				dat(i2)=Str(Idat(i2))
				LastReg=Reg(1)
			End If
		Next
		
		'#####################-CALL-#####################
		
	Elseif Ucase(cmdn)=CALL2.title Then
		CALL2.p1=cmdp1
		For i As Integer=1 To anzfuncs
			If CALL2.p1= functions(i).nam Then
				If Command(2)="-d" Or Command(2)="-f" Then Print #ffout,"Funktionsaufruf: "+functions(i).nam
				If Command(2)="-d" Or Command(2)="-f" Then Print #ffout,"----------------------------------------"
				execFunc(i)
				If Command(2)="-d" Or Command(2)="-f" Then Print #ffout,"----------------------------------------"
			End If
		Next
		
		'#####################-FUNC-#####################
		
	Elseif Ucase(cmdn)="FUNC" Then
		Exit Do
		
		'#####################-JMP-#####################
		
	Elseif Ucase(cmdn)=JMP.title Then
		JMP.p1=cmdp1
		If Command(2)="-d" Then Print #ffout,"Sprung zu "+JMP.p1
		Dim As String jmptemp2
		For i As Integer=1 To 999
			jmptemp2=ReadPrevLine(ff)
			If Instr(jmptemp2,"label "+JMP.p1) Then 
				Exit For
			End If
		Next
		Dim As String jmptemp
		For i As Integer=1 To 999
			jmptemp=ReadNextLine(ff)
			If Instr(jmptemp,"label "+JMP.p1) Then 
				Exit For
			End If
		Next
		
		'#####################-CMP-#####################
		
	Elseif Ucase(cmdn)=CMP.title Then
		CMP.p1=cmdp1
		CMP.p2=cmdp2
		For i As Integer=1 To 12
			If Ucase(CMP.p1)=Reg(i).title Then
				cmpp1=Reg(i).content.scontent
			End If
			If Ucase(CMP.p1)=Str(Val(CMP.p1)) Then
				cmpp1=Str(CMP.p1)
			End If
			If Ucase(CMP.p2)=Reg(i).title Then
				cmpp2=Reg(i).content.scontent
			End If
			If Ucase(CMP.p2)=Str(Val(CMP.p2)) Then
				cmpp2=Str(CMP.p2)
			End If
		Next
		For i2 As Integer=1 To null2
			If CMP.p1="["+datvar(i2)+"]" Then
				cmpp1=dat(i2)
			End If
			If CMP.p2="["+datvar(i2)+"]" Then
				cmpp2=dat(i2)
			End If
			If Instr(CMP.p1,"%") Then
				cmpp1=Mid(CMP.p1,1)
			End If
			If Instr(CMP.p2,"%") Then
				cmpp2=Mid(CMP.p2,1)
			End If
		Next
		
		'#####################-JE-#####################
		
	Elseif Ucase(cmdn)=JE.title Then
		JE.p1=cmdp1
		If cmpp1=cmpp2 Then
			If Command(2)="-d" Then Print #ffout,"Sprung zu "+JE.p1
			Dim As String Jnetemp2
			For i As Integer=1 To 999
				Jnetemp2=ReadPrevLine(ff)
				If Instr(Jnetemp2,"label "+JE.p1) Then 
					Exit For
				End If
			Next
			Dim As String Jnetemp
			For i As Integer=1 To 999
				Jnetemp=ReadNextLine(ff)
				If Instr(Jnetemp,"label "+JE.p1) Then 
					Exit For
				End If
			Next
		End If
		
		'#####################-JNE-#####################
		
	Elseif Ucase(cmdn)=JNE.title Then
		JNE.p1=cmdp1
		If cmpp1<>cmpp2 Then
			If Command(2)="-d" Then Print #ffout,"Sprung zu "+JNE.p1
			Dim As String Jnetemp2
			For i As Integer=1 To 999
				Jnetemp2=ReadPrevLine(ff)
				If Instr(Jnetemp2,"label "+JNE.p1) Then 
					Exit For
				End If
			Next
			Dim As String Jnetemp
			For i As Integer=1 To 999
				Jnetemp=ReadNextLine(ff)
				If Instr(Jnetemp,"label "+JNE.p1) Then 
					Exit For
				End If
			Next
		End If
		
		'#####################-JA-#####################
		
	Elseif Ucase(cmdn)=JA.title Then
		JA.p1=cmdp1
		If cmpp1>cmpp2 Then
			If Command(2)="-d" Then Print #ffout,"Sprung zu "+JA.p1
			Dim As String Jatemp2
			For i As Integer=1 To 999
				Jatemp2=ReadPrevLine(ff)
				If Instr(Jatemp2,"label "+JA.p1) Then 
					Exit For
				End If
			Next
			Dim As String Jatemp
			For i As Integer=1 To 999
				Jatemp=ReadNextLine(ff)
				If Instr(Jatemp,"label "+JA.p1) Then 
					Exit For
				End If
			Next
		End If
	
	'#####################-JB-#####################
		
	Elseif Ucase(cmdn)=JB.title Then
		JB.p1=cmdp1
		If cmpp1<cmpp2 Then
			If Command(2)="-d" Then Print #ffout,"Sprung zu "+JB.p1
			Dim As String Jbtemp2
			For i As Integer=1 To 999
				Jbtemp2=ReadPrevLine(ff)
				If Instr(Jbtemp2,"label "+JB.p1) Then 
					Exit For
				End If
			Next
			Dim As String Jbtemp
			For i As Integer=1 To 999
				Jbtemp=ReadNextLine(ff)
				If Instr(Jbtemp,"label "+JB.p1) Then 
					Exit For
				End If
			Next
		End If
	
	'#####################-JBE-#####################
		
	Elseif Ucase(cmdn)=JBE.title Then
		JBE.p1=cmdp1
		If cmpp1<=cmpp2 Then
			If Command(2)="-d" Then Print #ffout,"Sprung zu "+JBE.p1
			Dim As String Jbetemp2
			For i As Integer=1 To 999
				Jbetemp2=ReadPrevLine(ff)
				If Instr(Jbetemp2,"label "+JBE.p1) Then 
					Exit For
				End If
			Next
			Dim As String Jbetemp
			For i As Integer=1 To 999
				Jbetemp=ReadNextLine(ff)
				If Instr(Jbetemp,"label "+JBE.p1) Then 
					Exit For
				End If
			Next
		End If
		
		'#####################-JAE-#####################
		
	Elseif Ucase(cmdn)=JAE.title Then
		JAE.p1=cmdp1
		If cmpp1>=cmpp2 Then
			If Command(2)="-d" Then Print #ffout,"Sprung zu "+JAE.p1
			Dim As String Jaetemp2
			For i As Integer=1 To 999
				Jaetemp2=ReadPrevLine(ff)
				If Instr(Jaetemp2,"label "+JAE.p1) Then 
					Exit For
				End If
			Next
			Dim As String Jaetemp
			For i As Integer=1 To 999
				Jaetemp=ReadNextLine(ff)
				If Instr(Jaetemp,"label "+JAE.p1) Then 
					Exit For
				End If
			Next
		End If
	
	End If
	Sleep 1
	If Command(2)="-d" Then
		Print #ffout,"AX: "+Reg(1).content.scontent
		Print #ffout,"BX: "+Reg(2).content.scontent
		Print #ffout,"CX: "+Reg(3).content.scontent
		Print #ffout,"DX: "+Reg(4).content.scontent
		Print #ffout,"-------------------------------------------------"
	End If
Loop 
If Command(2)="-r" Then
	For i As Integer=1 To 12
		Print Reg(i).title+": "+Reg(i).content.scontent
	Next
End If
Close #ff
Close #ffout

Function strreplace(s As String, erlaubt As String)As String
  Dim t As String = ""
  For i As Integer =1 To Len(s)
    If Instr(erlaubt, Mid(s, i, 1)) > 0 Then
      t = t + Mid(s, i, 1)
    End If
  Next i
  strreplace = t
End Function

Sub ExecFunc(fu As Integer)
	Dim As Integer execfuncline
	For i As Integer=1 To functions(fu).anzlines
		execfuncline+=1
		If Command(2)="-d" Or Command(2)="-f" Then Print #ffout,functions(fu).code(execfuncline)
		If functions(fu).code(execfuncline) = "" Then Continue For
		spac = Instr(functions(fu).code(execfuncline), " ") 
		If spac < 1 Then Continue For
		cmdn = Left(functions(fu).code(execfuncline),spac-1) 
		comma = Instr(spac, functions(fu).code(execfuncline), ",") 
		'If comma < 1 Then Continue Do
		cmdp1=  Trim(Mid(functions(fu).code(execfuncline), spac + 1, comma - spac - 1))
		cmdp2 = Trim(Mid(functions(fu).code(execfuncline), comma + 1)) 
		
			
		'#####################-MOV-#####################
	
	If Ucase(cmdn)=MOV.title Then
		MOV.p1=cmdp1
		MOV.p2=cmdp2
		For i3 As Integer=1 To null2
			If MOV.p1="["+datvar(i3)+"]" Then
				Idat(i3)=Val(Dat(i3))
				For i4 As Integer=1 To 12
					If MOV.p2=Reg(i4).title Then
						Idat(i3)=Val(Reg(i4).content.scontent)
					Elseif MOV.p2="["+datvar(i4)+"]" Then
						Idat(i3)=Val(dat(i4))
					Else
						Idat(i3)=Val(MOV.p2)
					End If
				Next
				Dat(i3)=Str(Idat(i3))
			End If
		Next
		For i3 As Integer=1 To 12
			If Ucase(MOV.p1)=Reg(i3).title Then
				Reg(i3).content.content=Val(Reg(i3).content.scontent)
				For i4 As Integer=1 To 12
					If Ucase(MOV.p2)=Reg(i4).title Then
						Reg(i3).content.scontent=Reg(i4).content.scontent
					End If
				Next
				For i4 As Integer=1 To null2
				If Instr(MOV.p2,"["+datvar(i4)+"]") Then
					Reg(i3).content.scontent=dat(i4)
				End If
				Next
				If Instr(Ucase(MOV.p2),"%") Then
					For i5 As Integer=1 To null2
						If Mid(MOV.p2,2)=datvar(i5) Then
							Reg(i3).content.scontent=dat(i5)
							LastReg=Reg(i3)
						End If
					Next
				End If
				If (Instr(MOV.p2,"h")And Instr(MOV.p2,"0")) Or (Instr(MOV.p2,"b") And Instr(MOV.p2,"1"))Then
					Reg(i3).content.scontent=MOV.p2
				End If
				If MOV.p2=Str(Val(MOV.p2)) Then
					Reg(i3).content.content=Val(MOV.p2)
					Reg(i3).content.scontent=Str(Reg(i3).content.content)
				End If
			End If
		Next
			
	 '#####################-DEC-#####################
	
	Elseif Ucase(cmdn)=DEC.title Then
		DEC.p1=cmdp1
		For i As Integer=1 To null2
			If Ucase(DEC.p1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content-=1
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(i)
			Elseif DEC.p1="["+Datvar(i)+"]" Then
				Idat(i)=Val(Dat(i))
				Idat(i)-=1
				Dat(i)=Str(Idat(i))
			End If
		Next
		
	'#####################-INC-#####################
	
	Elseif Ucase(cmdn)=INC.title Then
		INC.p1=cmdp1
		For i As Integer=1 To null2
			If Ucase(INC.p1)=Reg(i).title Then 
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content+=1
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(i)
				Elseif INC.p1="["+Datvar(i)+"]" Then
					Idat(i)=Val(Dat(i))
					Idat(i)+=1
					Dat(i)=Str(Idat(i))
			End If
		Next
		
	'#####################-ADD-#####################
	
	Elseif Ucase(cmdn)=ADD.title Then
		ADD.p1=cmdp1
		ADD.p2=cmdp2
		For i3 As Integer=1 To null2
			If ADD.p1="["+datvar(i3)+"]" Then
				Idat(i3)=Val(Dat(i3))
				For i4 As Integer=1 To 12
					If ADD.p2=Reg(i4).title Then
						Idat(i3)+=Val(Reg(i4).content.scontent)
					Elseif ADD.p2="["+datvar(i4)+"]" Then
						Idat(i3)+=Val(dat(i4))
					Else
						Idat(i3)+=Val(ADD.p2)
					End If
				Next
				Dat(i3)=Str(Idat(i3))
			End If
		Next
		For i3 As Integer=1 To 12
			If Ucase(ADD.p1)=Reg(i3).title Then
				Reg(i3).content.content=Val(Reg(i3).content.scontent)
				For i4 As Integer=1 To 12
					If ADD.p2=Reg(i4).title Then
						Reg(i3).content.content+=Val(Reg(i4).content.scontent)
					Elseif ADD.p2="["+datvar(i4)+"]" Then
						Reg(i3).content.content+=Val(dat(i4))
					Else
						Reg(i3).content.content+=Val(ADD.p2)
					End If
				Next
				Reg(i3).content.scontent=Str(Reg(i3).content.content)
			End If
		Next
			
	'#####################-SUB-#####################
	
	 Elseif Ucase(cmdn)=SUB2.title Then
		SUB2.p1=cmdp1
		SUB2.p2=cmdp2
		For i3 As Integer=1 To null2
			If SUB2.p1="["+datvar(i3)+"]" Then
				Idat(i3)=Val(Dat(i3))
				For i4 As Integer=1 To 12
					If SUB2.p2=Reg(i4).title Then
						Idat(i3)-=Val(Reg(i4).content.scontent)
					Elseif SUB2.p2="["+datvar(i4)+"]" Then
						Idat(i3)-=Val(dat(i4))
					Else
						Idat(i3)-=Val(SUB2.p2)
					End If
				Next
				Dat(i3)=Str(Idat(i3))
			End If
		Next
		For i3 As Integer=1 To 12
			If Ucase(SUB2.p1)=Reg(i3).title Then
				Reg(i3).content.content=Val(Reg(i3).content.scontent)
				For i4 As Integer=1 To 12
					If SUB2.p2=Reg(i4).title Then
						Reg(i3).content.content-=Val(Reg(i4).content.scontent)
					Elseif SUB2.p2="["+datvar(i4)+"]" Then
						Reg(i3).content.content-=Val(dat(i4))
					Else
						Reg(i3).content.content-=Val(SUB2.p2)
					End If
				Next
				Reg(i3).content.scontent=Str(Reg(i3).content.content)
			End If
		Next
		
		'#####################-INT-#####################
		
	Elseif Ucase(cmdn)=INT2.title Then
		INT2.p1=cmdp1
		If INT2.p1="42h" Then
			If Command(2)<>"--debug" Then SysInterrupt()
		End If
		If INT2.p1="10h" Then 
			If Command(2)<>"--debug" Then BIOSInterrupt()
		End If
		
		'#####################-NEG-#####################
		
	Elseif Ucase(cmdn)=NEG.title Then
		NEG.p1=cmdp1
		For i As Integer=1 To 12
			If Ucase(NEG.p1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content=0-Reg(i).content.content
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(i)
			End If
		Next
		For i2 As Integer=1 To null2
			If NEG.p1="["+datvar(i2)+"]" Then
				Idat(i2)=Val(dat(i2))
				Idat(i2)=0-Idat(i2)
				dat(i2)=Str(Idat(i2))
			End If
		Next
		
		'#####################-MUL-#####################
		
	Elseif Ucase(cmdn)=MUL.title Then
		MUL.p1=cmdp1
		If Ucase(MUL.p1)=Str(Val(MUL.p1)) Then
			Reg(1).content.content=Val(Reg(1).content.scontent)
			Reg(1).content.content=Val(MUL.p1)*Reg(1).content.content
			Reg(1).content.scontent=Str(Reg(1).content.content)
			LastReg=Reg(1)
		End If
		For i As Integer=1 To 12
			If Ucase(MUL.p1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Reg(i).content.content*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(1)
			End If
		Next
		For i2 As Integer=1 To null2
			If MUL.p1="["+datvar(i2)+"]" Then
				Idat(i2)=Val(dat(i2))
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Idat(i2)*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				dat(i2)=Str(Idat(i2))
				LastReg=Reg(1)
			End If
		Next
		
		'#####################-DIV-#####################
		
	Elseif Ucase(cmdn)=DIV.title Then
		DIV.p1=cmdp1
		If Ucase(DIV.p1)=Str(Val(DIV.p1)) Then
			Reg(1).content.content=Val(Reg(1).content.scontent)
			Reg(1).content.content=Reg(1).content.content/Val(DIV.p1)
			Reg(1).content.scontent=Str(Reg(1).content.content)
			LastReg=Reg(1)
		End If
		For i As Integer=1 To 12
			If Ucase(DIV.p1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Reg(1).content.content/Reg(i).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				Reg(i).content.scontent=Str(Reg(i).content.content)
				LastReg=Reg(1)
			End If
		Next
		For i2 As Integer=1 To null2
			If DIV.p1="["+datvar(i2)+"]" Then
				Idat(i2)=Val(dat(i2))
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Reg(1).content.content/Idat(i2)
				Reg(1).content.scontent=Str(Reg(1).content.content)
				dat(i2)=Str(Idat(i2))
				LastReg=Reg(1)
			End If
		Next
		
		'#####################-CALL-#####################
		
	Elseif Ucase(cmdn)=CALL2.title Then
		CALL2.p1=cmdp1
		For i As Integer=1 To anzfuncs
			If CALL2.p1= functions(i).nam Then
				If Command(2)="-d" Or Command(2)="-f" Then Print #ffout,"Funktionsaufruf: "+functions(i).nam
				If Command(2)="-d" Or Command(2)="-f" Then Print #ffout,"----------------------------------------"
				execFunc(i)
				If Command(2)="-d" Or Command(2)="-f" Then Print #ffout,"----------------------------------------"
			End If
		Next
		
		'#####################-NOGOES-#####################
		
		Elseif Ucase(cmdn)=JMP.title Or Ucase(cmdn)=JE.title Or Ucase(cmdn)=JNE.title Or Ucase(cmdn)=JA.title Or Ucase(cmdn)=JB.title Or Ucase(cmdn)=JAE.title Or Ucase(cmdn)=JBE.title Then
			If Command(2)="--debug" Then
				Color 4
				Print #ffout,"Fehler: Sprünge sind in Funktionen nicht erlaubt. Gefunden: '"+cmdn+"'"
				Color 7
			End If
			
		Elseif Ucase(cmdn)="FUNC" Then
			If Command(2)="--debug" Then
				Color 4
				Print #ffout,"Fehler: In Funktionen können keine weiteren Funktionen erstellt werden"
				Color 7
			End If
		
			'#####################-RET-#####################
			
		Elseif Ucase(cmdn)=RET.title Then
			Exit For
		End If
		Sleep 1
	Next
End Sub

Function ReadNextLine ( ByVal FF As Integer ) As String
   Dim Stri As String
   LineStart = Seek ( FF )
   Line Input #FF, Stri
   Return Stri
End Function
Function ReadPrevLine ( ByVal FF As Integer, ByVal bracke As UByte = 10, ByVal Length As Integer = 2 ) As String
   Dim Position As Integer
   Dim Char As UByte
   Position = LineStart
   For Position As Integer = LineStart-1-Length To 0 Step -1
      Get #FF, Position, Char
      If Char = bracke Or Position = 0 Then
         LineStart = Position+1
         Exit For
      EndIf
   Next
   Seek #FF, LineStart
   Return ReadNextLine ( FF )
End Function 
