#INCLUDE "vbcompat.bi"
#Include "Include/inc_datatypes.bi"
#Include "Include/inc_register.bi"
#Include "Include/inc_flags.bi"
#Include "Include/inc_interrupts.bi"

Type Func
	As String nam,nam2
	As String code(999)
	As Integer anzlines
End Type

Type Label
	As String nam,nam2
	As String code(999)
	As Integer anzlines
End Type

Dim Shared As Func functions(999)
Dim Shared As Label labels(999)

Dim Shared As String lina,lina2,lin,lindata,lindataa,lindataa2,cmdn,cmdp1,cmdp2,dat(999),datvar(999),null
Dim Shared As String flina,flina2,flin,fflina,fflina2,fflin,fnull,fline,cmpp1,cmpp2
Dim Shared As Integer spac,comma,null2,idat(999),lines,anzfuncs,anzlabels,linestart,ffout,ffout2,fff,currentline
Declare Function StrReplace(s As String, erlaubt As String)As String
Declare Function StrReplace2 (Byval StrEx as String, Byval StrMask as String, Byval StrRplce as String) as String

'Var fpreout=Freefile
'Open Command(1)+".asm" For Append As #fpreout
'Print #fpreout,";aihdfgajgkdgfajgsdfjagfdj"

If Command(1)="-v" Or Command(1)="--version" Then
	Print "Assembler-2000 Version 1.0 vom 27.7.2011"
	End
End If
If Command(1)="-h" Or Command(1)="--help" Then
	Print "Aufruf: ./asc [DATEI] [OPTION]"
	Print " Beispiel: ./asc test -d"
	Print "Die Datei als Assembler-2000 Quellcode mit Hilfe des fbc kompilieren."
	Print ""
	Print "  -h, --help      Diese Hilfe anzeigen"
	Print "  -v, --version   Versionsnummer anzeigen"
	Print "  -d              Die erstellte 'output.bas' nicht löschen"
	Print "  -l, --license   Lizenzhinweis lesen"
	End
End If
If Command(1)="-l" Or Command(1)="--license" Then
	Print "DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE"
	Print "         Version 2, December 2004"
	Print ""
	Print "Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>"
	Print ""
	Print "Everyone is permitted to copy and distribute verbatim or modified"
	Print "copies of this license document, and changing it is allowed as long"
	Print "as the name is changed."
	Print ""
	Print "        DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE"
	Print " TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION"
	Print ""
	Print " 0. You just DO WHAT THE FUCK YOU WANT TO. "
	End
End If
If Command(1)="" Then
	Print "asc: Fehlender Operand"
	Print "'asc --help' gibt weitere Informationen."
	End
End If

fff=Freefile
Open Command(1)+".asm" For Input As #fff
If Fileexists(Command(1)+".asm") Then
	Print "Datei '"+Command(1)+".asm' gefunden"
Else
	Print "Datei '"+Command(1)+".asm' wurde nicht gefunden"
	End
End If
Do Until Eof(fff)
Line Input #fff,flina
	flina2=StrReplace(flina,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,:;-_!§$%&/()[]=?ß*'+# ")
	
	'#####################-COMMENTARS-#####################
	
	If Instr(flina2,";") Then
		Dim As Integer possem=Instr(flina2,";")
		flin=Left(flina2,possem-1)
	Else
		flin=flina2
	End If
	
	If Instr(Ucase(flin),"FUNC") Then
		anzfuncs+=1
		functions(anzfuncs).nam=Mid(flin,6)
	End If
Loop
Close #fff

Var ff=Freefile
Open Command(1)+".asm" For Input As #ff
ffout=Freefile
Open "output.bas" For Output As #ffout
Print #ffout,"Dim Shared As String regax,regbx,regcx,regdx,regah,regal,regbh,regbl,regch,regcl,regdh,regdl,cmpp1,cmpp2"
Print #ffout,"Dim Shared As Integer bit1,bit2,tempreg,tempreg2"
Print #ffout,""
Print #ffout,"Declare Sub SetColor()"
Print #ffout,"Declare Function GetColor() As Integer"
Print #ffout,""
For i As Integer=1 To anzfuncs
	Print #ffout,"Declare Sub Func"+functions(i).nam+"()"
Next
Print #ffout,""
currentline=2
Do Until Eof(ff)
	Line Input #ff,lina
	currentline+=1
	If flina=";aihdfgajgkdgfajgsdfjagfdj" Then Exit Do
	lina2=StrReplace(lina,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,:;-_!§$%&/()[]=?ß*'+# ")
	
	If Instr(lina2,";") Then
		Dim As Integer possem=Instr(lina2,";")
		lin=Left(lina2,possem-1)
	Else
		lin=lina2
	End If
	If Instr(Ucase(lin),"RET") Then Print #ffout,"End Sub"
	 If lin=".data" Then
		Input #ff,null2
		For i As Integer=1 To null2
			Line Input #ff,lindataa
			lindataa2=StrReplace(lindataa,"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,:;-_!§$%&/()[]=?ß*'+# ")
			If Instr(lindataa2,";") Then
				Dim As Integer possem=Instr(lindataa2,";")
				lindata=Left(lindataa2,possem-1)
			Else
				lindata=lindataa2
			End If
			datvar(i)=Left(lindata,5)
			Print #ffout,"Dim Shared As String datvar"+datvar(i)
			dat(i)=Mid(lindata,6)
			Print #ffout,"datvar"+datvar(i)+"="+Chr(34)+dat(i)+Chr(34)
		Next
	End If
	
	If lin = "" Then Continue Do 
	spac = Instr(lin, " ") 
	If spac < 1 Then Continue Do
	cmdn = Left(lin,spac-1) 
	comma = Instr(spac, lin, ",") 
	'If comma < 1 Then Continue Do
	cmdp1=  Trim(Mid(lin, spac + 1, comma - spac - 1))
    cmdp2 = Trim(Mid(lin, comma + 1)) 
    If Ucase(cmdn)="MOV" Then
		For i As Integer=1 To 12+null2
			If Ucase(cmdp1)=Reg(i).title Then
				For i2 As Integer=1 To 12
					If Ucase(cmdp2)=Reg(i2).title Then
						Print #ffout,"Reg"+Reg(i).title+"="+"Reg"+Reg(i2).title
						Reg(i).content.scontent=Reg(i2).content.scontent
					End If
				Next
				For i2 As Integer=1 To null2
					If Instr(cmdp2,"%") Then
						Print #ffout,"Reg"+Reg(i).title+"=datvar"+Mid(cmdp2,2)
						Reg(i).content.scontent=Mid(cmdp2,2)
					Elseif cmdp2="["+datvar(i2)+"]" Then
						Print #ffout,"Reg"+Reg(i).title+"=datvar"+datvar(i2)
						Reg(i).content.scontent=dat(i2)
					End If
				Next
				If (Instr(cmdp2,"h") And (Instr(cmdp2,"0")Or Instr(cmdp2,"1") Or Instr(cmdp2,"F"))) Or (Instr(cmdp2,"b") And Instr(cmdp2,"1")) Then
					Print #ffout,"Reg"+Reg(i).title+"="+Chr(34)+cmdp2+Chr(34)
					Reg(i).content.scontent=cmdp2
				End If
				If cmdp2=Str(Val(cmdp2)) Then
					Print #ffout,"Reg"+Reg(i).title+"="+Chr(34)+cmdp2+Chr(34)
					Reg(i).content.scontent=cmdp2
				End If
			End If
			If Ucase(cmdp1)="["+datvar(i)+"]" Then
				For i2 As Integer=1 To 12
					If Ucase(cmdp2)=Reg(i2).title Then
						Print #ffout,"datvar"+datvar(i)+"="+"Reg"+Reg(i2).title
						dat(i)=Reg(i2).content.scontent
					End If
				Next
				For i2 As Integer=1 To null2
					If Instr(cmdp2,"%") Then
						Print #ffout,"datvar"+datvar(i)+Reg(i).title+"=datvar"+Mid(cmdp2,2)
						dat(i)=Mid(cmdp2,2)
					Elseif cmdp2="["+datvar(i2)+"]" Then
						Print #ffout,"datvar"+datvar(i)+Reg(i).title+"=datvar"+datvar(i2)
						dat(i)=dat(i2)
					End If
				Next
				If cmdp2=Str(Val(cmdp2)) Then
					Print #ffout,"datvar"+datvar(i)+Reg(i).title+"="+Chr(34)+cmdp2+Chr(34)
					dat(i)=cmdp2
				End If
			End If
		Next
		
	Elseif Ucase(cmdn)="INT" Then
		If cmdp1="42h" Then
			Print #ffout,"If Regah="+Chr(34)+"01h"+Chr(34)+" Then"
			Print #ffout,"End"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"02h"+Chr(34)+" Then"
			Print #ffout,"Print Regax"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"03h"+Chr(34)+" Then"
			Print #ffout,"Sleep Val(Regal)"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"04h"+Chr(34)+" Then"
			Print #ffout,"Dim As String int04hin"
			Print #ffout,"int04hin=Chr(Getkey)"
			Print #ffout,"Regal=int04hin"
			Print #ffout,"Print int04hin"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"05h"+Chr(34)+" Then"
			Print #ffout,"Dim As String int05hin"
			Print #ffout,"Input "+Chr(34)+Chr(34)+",int05hin"
			Print #ffout,"Regdx=int05hin"
			Print #ffout,"End If"
		Elseif cmdp1="10h" Then
			Print #ffout,"If Regah="+Chr(34)+"00h"+Chr(34)+" Then"
				Print #ffout,"If Regal="+Chr(34)+"0Dh"+Chr(34)+" Then Screen 7:bit1=1:End If"
				Print #ffout,"If Regal="+Chr(34)+"0Eh"+Chr(34)+" Then Screen 8:bit1=1:End If"
				Print #ffout,"If Regal="+Chr(34)+"10h"+Chr(34)+" Then Screen 9"
				Print #ffout,"If Regal="+Chr(34)+"11h"+Chr(34)+" Then Screen 11"
				Print #ffout,"If Regal="+Chr(34)+"12h"+Chr(34)+" Then Screen 12"
				Print #ffout,"If Regal="+Chr(34)+"13h"+Chr(34)+" Then Screen 13:bit1=1:End If"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"02h"+Chr(34)+" Then"
				Print #ffout,"Locate Val(Regdh),Val(Regdl)"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"03h"+Chr(34)+" Then"
				Print #ffout,"Regdh=Str(Pos)"
				Print #ffout,"Regdl=Str(CsrLin)"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"08h"+Chr(34)+" Or Regah="+Chr(34)+"09h"+Chr(34)+" Then"
				Print #ffout,"SetColor()"
				Print #ffout,"Print Chr(Val(Regal))"
				Print #ffout,"Color 7"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"0Ah"+Chr(34)+" Then"
				Print #ffout,"Print Chr(Val(Regal))"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"0Bh"+Chr(34)+" Then"
				Print #ffout,"If Regbh="+Chr(34)+"00h"+Chr(34)+" Then SetColor()"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"0Ch"+Chr(34)+" Then"
				Print #ffout,"Pset (Val(Regdx),Val(Regcx)),Getcolor()"
			Print #ffout,"End If"
			Print #ffout,"If Regah="+Chr(34)+"4Fh"+Chr(34)+" Then"
				Print #ffout,"If Regal="+Chr(34)+"4Fh"+Chr(34)+" Then"
					Print #ffout,"If Regbx="+Chr(34)+"100"+Chr(34)+" Then Screenres 640,480,8"
					Print #ffout,"If Regbx="+Chr(34)+"101"+Chr(34)+" Then Screenres 640,480,8"
					Print #ffout,"If Regbx="+Chr(34)+"102"+Chr(34)+" Then Screenres 800,600,4"
					Print #ffout,"If Regbx="+Chr(34)+"103"+Chr(34)+" Then Screenres 800,600,8"
					Print #ffout,"If Regbx="+Chr(34)+"104"+Chr(34)+" Then Screenres 1024,768,4"
					Print #ffout,"If Regbx="+Chr(34)+"105"+Chr(34)+" Then Screenres 1024,768,8"
					Print #ffout,"If Regbx="+Chr(34)+"106"+Chr(34)+" Then Screenres 1280,1024,4"
					Print #ffout,"If Regbx="+Chr(34)+"107"+Chr(34)+" Then Screenres 1280,1024,8"
					Print #ffout,"If Regbx="+Chr(34)+"10D"+Chr(34)+" Then Screenres 320,200,15"
					Print #ffout,"If Regbx="+Chr(34)+"10E"+Chr(34)+" Then Screenres 320,200,16"
					Print #ffout,"If Regbx="+Chr(34)+"10F"+Chr(34)+" Then Screenres 320,200,24"
					Print #ffout,"If Regbx="+Chr(34)+"110"+Chr(34)+" Then Screenres 640,480,15"
					Print #ffout,"If Regbx="+Chr(34)+"111"+Chr(34)+" Then Screenres 640,480,16"
					Print #ffout,"If Regbx="+Chr(34)+"112"+Chr(34)+" Then Screenres 640,480,24"
					Print #ffout,"If Regbx="+Chr(34)+"113"+Chr(34)+" Then Screenres 800,600,15"
					Print #ffout,"If Regbx="+Chr(34)+"114"+Chr(34)+" Then Screenres 800,600,16"
					Print #ffout,"If Regbx="+Chr(34)+"115"+Chr(34)+" Then Screenres 800,600,24"
					Print #ffout,"If Regbx="+Chr(34)+"116"+Chr(34)+" Then Screenres 1024,768,15"
					Print #ffout,"If Regbx="+Chr(34)+"117"+Chr(34)+" Then Screenres 1024,768,16"
					Print #ffout,"If Regbx="+Chr(34)+"118"+Chr(34)+" Then Screenres 1024,768,24"
					Print #ffout,"If Regbx="+Chr(34)+"119"+Chr(34)+" Then Screenres 1280,1024,15"
					Print #ffout,"If Regbx="+Chr(34)+"11A"+Chr(34)+" Then Screenres 1280,1024,16"
					Print #ffout,"If Regbx="+Chr(34)+"11B"+Chr(34)+" Then Screenres 1280,1024,24"
					Print #ffout,"If Regbx="+Chr(34)+"11C"+Chr(34)+" Then Screenres 1600,1200,8"
					Print #ffout,"If Regbx="+Chr(34)+"11D"+Chr(34)+" Then Screenres 1600,1200,15"
					Print #ffout,"If Regbx="+Chr(34)+"11E"+Chr(34)+" Then Screenres 1600,1200,16"
					Print #ffout,"If Regbx="+Chr(34)+"11F"+Chr(34)+" Then Screenres 1600,1200,24"
				Print #ffout,"End If"
			Print #ffout,"End If"
		End If
		
		Elseif Ucase(cmdn)="DEC" Then
		For i As Integer=1 To null2+12
			If Ucase(cmdp1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content-=1
				Reg(i).content.scontent=Str(Reg(i).content.content)
				Print #ffout,"tempreg=Val(Reg"+Reg(i).title+")"
				Print #ffout,"tempreg-=1"
				Print #ffout,"Reg"+Reg(i).title+"=Str(tempreg)"
			Elseif cmdp1="["+Datvar(i)+"]" Then
				Idat(i)=Val(Dat(i))
				Idat(i)-=1
				Dat(i)=Str(Idat(i))
				Print #ffout,"tempreg=Val(datvar"+datvar(i)+")"
				Print #ffout,"tempreg-=1"
				Print #ffout,"datvar"+datvar(i)+"=Str(tempreg)"
			End If
		Next
		
		Elseif Ucase(cmdn)="INC" Then
		For i As Integer=1 To null2+12
			If Ucase(cmdp1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content-=1
				Reg(i).content.scontent=Str(Reg(i).content.content)
				Print #ffout,"tempreg=Val(Reg"+Reg(i).title+")"
				Print #ffout,"tempreg+=1"
				Print #ffout,"Reg"+Reg(i).title+"=Str(tempreg)"
			Elseif cmdp1="["+Datvar(i)+"]" Then
				Idat(i)=Val(Dat(i))
				Idat(i)-=1
				Dat(i)=Str(Idat(i))
				Print #ffout,"tempreg=Val(datvar"+datvar(i)+")"
				Print #ffout,"tempreg+=1"
				Print #ffout,"datvar"+datvar(i)+"=Str(tempreg)"
			End If
		Next
		
		Elseif Ucase(cmdn)="ADD" Then
		For i3 As Integer=1 To null2
			If cmdp1="["+datvar(i3)+"]" Then
				Idat(i3)=Val(Dat(i3))
				Print #ffout,"tempreg=Val(datvar"+datvar(i3)+")"
				For i4 As Integer=1 To 12
					If Ucase(cmdp2)=Reg(i4).title Then
						Idat(i3)+=Val(Reg(i4).content.scontent)
						Print #ffout,"tempreg+=Val(Reg"+Reg(i4).title+")"
						Exit For
					Elseif cmdp2="["+datvar(i4)+"]" Then
						Idat(i3)+=Val(dat(i4))
						Print #ffout,"tempreg+=Val(datvar"+datvar(i4)+")"
						Exit For
					Elseif cmdp2=Str(Val(cmdp2)) Then
						Idat(i3)+=Val(cmdp2)
						Print #ffout,"tempreg+="+cmdp2
						Exit For
					End If
				Next
				Dat(i3)=Str(Idat(i3))
				Print #ffout,"datvar"+datvar(i3)+"=Str(tempreg)"
			End If
		Next
		For i3 As Integer=1 To 12
			If Ucase(cmdp1)=Reg(i3).title Then
				Reg(i3).content.content=Val(Reg(i3).content.scontent)
				Print #ffout,"tempreg=Val(Reg"+Reg(i3).title+")"
				For i4 As Integer=1 To 12
					If Ucase(cmdp2)=Reg(i4).title Then
						Reg(i3).content.content+=Val(Reg(i4).content.scontent)
						Print #ffout,"tempreg+=Val(Reg"+Reg(i4).title+")"
						Exit For
					Elseif cmdp2="["+datvar(i4)+"]" Then
						Reg(i3).content.content+=Val(dat(i4))
						Print #ffout,"tempreg+=Val(datvar"+datvar(i4)+")"
						Exit For
					Elseif cmdp2=Str(Val(cmdp2)) Then
						Reg(i3).content.content+=Val(cmdp2)
						Print #ffout,"tempreg+="+cmdp2
						Exit For
					End If
				Next
				Reg(i3).content.scontent=Str(Reg(i3).content.content)
				Print #ffout,"Reg"+Reg(i3).title+"=Str(tempreg)"
			End If
		Next
		
		Elseif Ucase(cmdn)="SUB" Then
		For i3 As Integer=1 To null2
			If cmdp1="["+datvar(i3)+"]" Then
				Idat(i3)=Val(Dat(i3))
				Print #ffout,"tempreg=Val(datvar"+datvar(i3)+")"
				For i4 As Integer=1 To 12
					If Ucase(cmdp2)=Reg(i4).title Then
						Idat(i3)-=Val(Reg(i4).content.scontent)
						Print #ffout,"tempreg-=Val(Reg"+Reg(i4).title+")"
						Exit For
					Elseif cmdp2="["+datvar(i4)+"]" Then
						Idat(i3)-=Val(dat(i4))
						Print #ffout,"tempreg-=Val(datvar"+datvar(i4)+")"
						Exit For
					Elseif cmdp2=Str(Val(cmdp2)) Then
						Idat(i3)-=Val(cmdp2)
						Print #ffout,"tempreg-="+cmdp2
						Exit For
					End If
				Next
				Dat(i3)=Str(Idat(i3))
				Print #ffout,"datvar"+datvar(i3)+"=Str(tempreg)"
			End If
		Next
		For i3 As Integer=1 To 12
			If Ucase(cmdp1)=Reg(i3).title Then
				Reg(i3).content.content=Val(Reg(i3).content.scontent)
				Print #ffout,"tempreg=Val(Reg"+Reg(i3).title+")"
				For i4 As Integer=1 To 12
					If Ucase(cmdp2)=Reg(i4).title Then
						Reg(i3).content.content-=Val(Reg(i4).content.scontent)
						Print #ffout,"tempreg-=Val(Reg"+Reg(i4).title+")"
						Exit For
					Elseif cmdp2="["+datvar(i4)+"]" Then
						Reg(i3).content.content-=Val(dat(i4))
						Print #ffout,"tempreg-=Val(datvar"+datvar(i4)+")"
						Exit For
					Elseif cmdp2=Str(Val(cmdp2)) Then
						Reg(i3).content.content-=Val(cmdp2)
						Print #ffout,"tempreg-="+cmdp2
						Exit For
					End If
				Next
				Reg(i3).content.scontent=Str(Reg(i3).content.content)
				Print #ffout,"Reg"+Reg(i3).title+"=Str(tempreg)"
			End If
		Next
		
		Elseif Ucase(cmdn)="NEG"Then
		For i As Integer=1 To 12
			If Ucase(cmdp1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(i).content.content=0-Reg(i).content.content
				Reg(i).content.scontent=Str(Reg(i).content.content)
				Print #ffout,"tempreg=Reg"+Reg(i).title
				Print #ffout,"tempreg=0-tempreg"
				Print #ffout,"Reg"+Reg(i).title+"=Str(tempreg)"
				LastReg=Reg(i)
			End If
		Next
		For i2 As Integer=1 To null2
			If cmdp2="["+datvar(i2)+"]" Then
				Idat(i2)=Val(dat(i2))
				Idat(i2)=0-Idat(i2)
				dat(i2)=Str(Idat(i2))
				Print #ffout,"tempreg=datvar"+datvar(i2)
				Print #ffout,"tempreg=0-tempreg"
				Print #ffout,"datvar"+datvar(i2)+"=Str(tempreg)"
			End If
		Next
		
		Elseif Ucase(cmdn)="MUL" Then
		For i As Integer=1 To 12+null2
			If Ucase(cmdp1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Reg(i).content.content*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				Reg(i).content.scontent=Str(Reg(i).content.content)
				Print #ffout,"tempreg2=Val(Reg"+Reg(i).title+")"
				Print #ffout,"tempreg=Val(Reg"+Reg(1).title+")"
				Print #ffout,"tempreg=tempreg*tempreg2"
				Print #ffout,"Reg"+Reg(1).title+"=Str(tempreg)"
				Print #ffout,"Reg"+Reg(i).title+"=Str(tempreg2)"
				Print Reg(i).title
				LastReg=Reg(1)
				Exit For
			End If
			If cmdp1="["+datvar(i)+"]" Then
				Idat(i)=Val(dat(i))
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Idat(i)*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				dat(i)=Str(Idat(i))
				Print #ffout,"tempreg2=Val(datvar"+datvar(i)+")"
				Print #ffout,"tempreg=Val(Reg"+Reg(1).title+")"
				Print #ffout,"tempreg=tempreg*tempreg2"
				Print #ffout,"Reg"+Reg(1).title+"=Str(tempreg)"
				Print #ffout,"datvar"+datvar(i)+"=Str(tempreg2)"
				LastReg=Reg(1)
				Exit For
			End If
			If Ucase(cmdp1)=Str(Val(cmdp1)) Then
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Val(cmdp1)*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				Print #ffout,"tempreg="+cmdp1
				Print #ffout,"tempreg=tempreg*Val(Reg"+Reg(1).title+")"
				Print #ffout,"Reg"+Reg(1).title+"=Str(tempreg)"
				LastReg=Reg(1)
				Exit For
			End If
		Next
		
		Elseif Ucase(cmdn)="DIV" Then
		For i As Integer=1 To 12+null2
			If Ucase(cmdp1)=Reg(i).title Then
				Reg(i).content.content=Val(Reg(i).content.scontent)
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Reg(i).content.content*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				Reg(i).content.scontent=Str(Reg(i).content.content)
				Print #ffout,"tempreg2=Val(Reg"+Reg(i).title+")"
				Print #ffout,"tempreg=Val(Reg"+Reg(1).title+")"
				Print #ffout,"tempreg=tempreg/tempreg2"
				Print #ffout,"Reg"+Reg(1).title+"=Str(tempreg)"
				Print #ffout,"Reg"+Reg(i).title+"=Str(tempreg2)"
				Print Reg(i).title
				LastReg=Reg(1)
				Exit For
			End If
			If cmdp1="["+datvar(i)+"]" Then
				Idat(i)=Val(dat(i))
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Idat(i)*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				dat(i)=Str(Idat(i))
				Print #ffout,"tempreg2=Val(datvar"+datvar(i)+")"
				Print #ffout,"tempreg=Val(Reg"+Reg(1).title+")"
				Print #ffout,"tempreg=tempreg/tempreg2"
				Print #ffout,"Reg"+Reg(1).title+"=Str(tempreg)"
				Print #ffout,"datvar"+datvar(i)+"=Str(tempreg2)"
				LastReg=Reg(1)
				Exit For
			End If
			If Ucase(cmdp1)=Str(Val(cmdp1)) Then
				Reg(1).content.content=Val(Reg(1).content.scontent)
				Reg(1).content.content=Val(cmdp1)*Reg(1).content.content
				Reg(1).content.scontent=Str(Reg(1).content.content)
				Print #ffout,"tempreg="+cmdp1
				Print #ffout,"tempreg=Val(Reg"+Reg(1).title+")/tempreg"
				Print #ffout,"Reg"+Reg(1).title+"=Str(tempreg)"
				LastReg=Reg(1)
				Exit For
			End If
		Next
		
		
		Elseif Ucase(cmdn)="CALL" Then
			Print #ffout,"Func"+cmdp1+"()"
			
		Elseif Ucase(cmdn)="LABEL" Then
			Print #ffout,cmdp1+":"
			
		Elseif Ucase(cmdn)="JMP" Then
			Print #ffout,"Goto "+cmdp1
			
		Elseif Ucase(cmdn)="FUNC" Then
			Print #ffout,"Sub Func"+cmdp1+"()"
			
		Elseif Ucase(cmdn)="CMP" Then
			cmpp1=cmdp1
			cmpp2=cmdp2
			If cmpp1=Str(Val(cmpp1)) Then
				Print #ffout,"cmpp1=Str("+cmpp1+")"
			Else
				For i As Integer=1 To 12+null2
					If Ucase(cmpp1)=Reg(i).title Then
						Print #ffout,"cmpp1=Reg"+cmpp1
					Elseif Ucase(cmpp1)="["+datvar(i)+"]" Then
						Print #ffout,"cmpp1=cmpp1"
					End If
				Next
			End If
			If cmpp2=Str(Val(cmpp2)) Then
				Print #ffout,"cmpp2=Str("+cmpp2+")"
			Else
				For i As Integer=1 To 12+null2
					If Ucase(cmpp2)=Reg(i).title Then
						Print #ffout,"cmpp2=Reg"+cmpp2
					Elseif Ucase(cmpp2)="["+datvar(i)+"]" Then
						Print #ffout,"cmpp2=cmpp2"
					End If
				Next
			End If
			
		Elseif Ucase(cmdn)="JE" Then
			Print #ffout,"If cmpp1=cmpp2 Then Goto "+cmdp1
		Elseif Ucase(cmdn)="JNE" Then
			Print #ffout,"If cmpp1<>cmpp2 Then Goto "+cmdp1
		Elseif Ucase(cmdn)="JA" Then
			Print #ffout,"If cmpp1>cmpp2 Then Goto "+cmdp1
		Elseif Ucase(cmdn)="JB" Then
			Print #ffout,"If cmpp1<cmpp2 Then Goto "+cmdp1
		Elseif Ucase(cmdn)="JAE" Then
			Print #ffout,"If cmpp1>=cmpp2 Then Goto "+cmdp1
		Elseif Ucase(cmdn)="JBE" Then
			Print #ffout,"If cmpp1<=cmpp2 Then Goto "+cmdp1
		Elseif Ucase(cmdn)="RET" Then
			Color 4
			Print "Fehler in Zeile "+Str(currentline)+". RET erwartet keine Parameter(Leerzeichen zählen als Parameter)."
			Color 7
		Else
			Color 4
			Print "Unbekannter Befehl: '"+cmdn+"' In Zeile "+Str(currentline)
			Color 7
    End If
Loop 
Print #ffout,"Sub SetColor()"
Print #ffout,"If Regbl="+Chr(34)+"0000b"+Chr(34)+" Then Color 0"
Print #ffout,"If Regbl="+Chr(34)+"0001b"+Chr(34)+" Then Color 1"
Print #ffout,"If Regbl="+Chr(34)+"0010b"+Chr(34)+" Then Color 2"
Print #ffout,"If Regbl="+Chr(34)+"0011b"+Chr(34)+" Then Color 3"
Print #ffout,"If Regbl="+Chr(34)+"0100b"+Chr(34)+" Then Color 4"
Print #ffout,"If Regbl="+Chr(34)+"0101b"+Chr(34)+" Then Color 5"
Print #ffout,"If Regbl="+Chr(34)+"0110b"+Chr(34)+" Then Color 6"
Print #ffout,"If Regbl="+Chr(34)+"0111b"+Chr(34)+" Then Color 7"
Print #ffout,"If Regbl="+Chr(34)+"1000b"+Chr(34)+" Then Color 8"
Print #ffout,"If Regbl="+Chr(34)+"1001b"+Chr(34)+" Then Color 9"
Print #ffout,"If Regbl="+Chr(34)+"1010b"+Chr(34)+" Then Color 10"
Print #ffout,"If Regbl="+Chr(34)+"1011b"+Chr(34)+" Then Color 11"
Print #ffout,"If Regbl="+Chr(34)+"1100b"+Chr(34)+" Then Color 12"
Print #ffout,"If Regbl="+Chr(34)+"1101b"+Chr(34)+" Then Color 13"
Print #ffout,"If Regbl="+Chr(34)+"1110b"+Chr(34)+" Then Color 14"
Print #ffout,"If Regbl="+Chr(34)+"1111b"+Chr(34)+" Then Color 15"
Print #ffout,"End Sub"

Print #ffout,"Function GetColor() As Integer"
Print #ffout,"If Regal="+Chr(34)+"0000b"+Chr(34)+" Then Return 0"
Print #ffout,"If Regal="+Chr(34)+"0001b"+Chr(34)+" Then Return 1"
Print #ffout,"If Regal="+Chr(34)+"0010b"+Chr(34)+" Then Return 2"
Print #ffout,"If Regal="+Chr(34)+"0011b"+Chr(34)+" Then Return 3"
Print #ffout,"If Regal="+Chr(34)+"0100b"+Chr(34)+" Then Return 4"
Print #ffout,"If Regal="+Chr(34)+"0101b"+Chr(34)+" Then Return 5"
Print #ffout,"If Regal="+Chr(34)+"0110b"+Chr(34)+" Then Return 6"
Print #ffout,"If Regal="+Chr(34)+"0111b"+Chr(34)+" Then Return 7"
Print #ffout,"If Regal="+Chr(34)+"1000b"+Chr(34)+" Then Return 8"
Print #ffout,"If Regal="+Chr(34)+"1001b"+Chr(34)+" Then Return 9"
Print #ffout,"If Regal="+Chr(34)+"1010b"+Chr(34)+" Then Return 10"
Print #ffout,"If Regal="+Chr(34)+"1011b"+Chr(34)+" Then Return 11"
Print #ffout,"If Regal="+Chr(34)+"1100b"+Chr(34)+" Then Return 12"
Print #ffout,"If Regal="+Chr(34)+"1101b"+Chr(34)+" Then Return 13"
Print #ffout,"If Regal="+Chr(34)+"1110b"+Chr(34)+" Then Return 14"
Print #ffout,"If Regal="+Chr(34)+"1111b"+Chr(34)+" Then Return 15"
Print #ffout,"End Function"
Close #ff
Close #ffout
Shell "fbc -w all output.bas"
If Fileexists("output") Then Print "Kompilieren erfolgreich"
Name "output",Command(1)
If Command(2)<>"-d" Then Shell "rm output.bas"

Function StrReplace(s As String, erlaubt As String)As String
  Dim t As String = ""
  For i As Integer =1 To Len(s)
    If Instr(erlaubt, Mid(s, i, 1)) > 0 Then
      t = t + Mid(s, i, 1)
    End If
  Next i
  strreplace = t
End Function

Function StrReplace2 (Byval StrEx as String, _
                     Byval StrMask as String, _
                     Byval StrRplce as String) as String

    If Len(StrEx)=0 or Len(StrMask)>Len(StrEx) Then Return StrEx

    Dim Buffer as String=StrEx
    Dim MaskSearch as UInteger
    Dim MFound as byte
    Dim lp as UInteger=1

    Do
        MaskSearch=InStr(lp,Buffer,StrMask)
        MFound=0

        If MaskSearch Then
            MFound=1:lp=MaskSearch+Len(StrRplce)

            ''
            Buffer=Left(Buffer,MaskSearch-1)+ _
            StrRplce+ _
            Right(Buffer,Len(Buffer)-(MaskSearch+(Len(StrMask)-1)))
            ''

        End If

    Loop while MFound=1

    Return Buffer
End Function
